/*
   "mcknofbd.mm"
   Simulation of the following system:
   M x^(2) + C x^(1) + K x = u + d
   u = 0, d = 0.5
*/

Func void main()
{
	Real t0,t1;
	Real h,dtsav;
	Matrix x0,TC,XC,UC;
	void diff_eqs(),link_eqs();

	t0 = 0.0;  //ߥ졼γϻ t=0 ˤ
	t1 = 20.0;  //ߥ졼νλ t=20 ˤ

	x0 = [1.0,0.0]';  //֤ x(0)=[1.0,0.0]' ˤ

	h = 1.0e-3; // ߥ졼ι1msecˤ
	dtsav = 1.0e-2;// ǡ10msec¸

	print "Now simulating\n";

// Ode()ˤäƥߥ졼Ԥ
	{TC,XC,UC} = Ode(t0,t1,x0,diff_eqs,link_eqs,h,dtsav);
// diff_eqs() ʬ򵭽Ҥؿ
// link_eqs() ʣʬδط򵭽Ҥؿ
// TC: ֤λ
// XC: x(t)λ
// UC: ϥ٥ȥλ

//  Ͳɽ롥 t, ļ x(t)
	mgplot(1,Array(TC),Array(XC(1,*)));
//  XC(1,*)XC1ܤɽ

//  ե¸
	print TC >> "TC.mat";
	print XC >> "XC.mat";
	print UC >> "UC.mat";
}

// diff_eqs() ʬ򵭽Ҥؿ
Func void diff_eqs(DX,t,X,UY)
Real t;
Matrix X,DX,UY;
{
	Real K,C,M;
	Matrix xp,up,dxp;
	Matrix A,B;
	Matrix d;

//  ʪѥ᡼
	K = 1.0; C = 0.4; M = 1.0;

//  A,B
	A = [[0,1][-K/M,-C/M]];
	B = [0,1/M]';

	xp = X; // X xp(t)ɽƤ롥

//  link_eqs()Ƿ׻UY롥
//  ǤUY=[0]
	up = UY;

//  d
	d = [0.5];

//  ʬ
	dxp = A * xp + B * (up + d);

//  Ǹ®٤DXϤ
	DX = [dxp];
}

// link_eqs() ʣʬδط򵭽Ҥؿ
Func void link_eqs(UY,t,X)
Real t;
Matrix UY,X;
{
	Matrix xp,up;

//  X xp(t)ɽƤ롥
	xp = X;

//  ǸUYupλtͤϤ
//  Ǥ0Ϥ
	UY = [0];
}

